SystemOrganization addCategory: #MTGG!

Object subclass: #LCS
	instanceVariableNames: 'types'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MTGG'!

!LCS class methodsFor: 'instance creation' stamp: 'SergioFedi 6/8/2016 10:37'!
newLand

	^(self new)
		addType: 'land';
		yourself.! !

!LCS methodsFor: 'public' stamp: 'SergioFedi 6/8/2016 10:38'!
addType: aString

	self types add: aString.! !

!LCS methodsFor: 'initialization' stamp: 'SergioFedi 6/8/2016 10:36'!
initialize

	super initialize.

	types := OrderedCollection new.! !

!LCS methodsFor: 'public' stamp: 'SergioFedi 6/8/2016 09:57'!
isLand

	^self types includes: 'land'.! !

!LCS methodsFor: 'private' stamp: 'SergioFedi 6/8/2016 09:58'!
types

	^types.! !

Object subclass: #MTGLibrary
	instanceVariableNames: 'collection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MTGG'!

!MTGLibrary methodsFor: 'private' stamp: 'SergioFedi 6/8/2016 09:30'!
add: aLCS

	collection add: aLCS.! !

!MTGLibrary methodsFor: 'private' stamp: 'SergioFedi 6/8/2016 10:24'!
collection

	^collection.! !

!MTGLibrary methodsFor: 'initialization' stamp: 'SergioFedi 6/8/2016 09:31'!
initialize

	super initialize.

	collection := OrderedCollection new.! !

!MTGLibrary methodsFor: 'public' stamp: 'SergioFedi 6/8/2016 10:51'!
isEmpty

	^self size = 0.! !

!MTGLibrary methodsFor: 'public' stamp: 'SergioFedi 6/8/2016 10:18'!
removeTop

	^self collection removeLast.! !

!MTGLibrary methodsFor: 'public' stamp: 'SergioFedi 6/8/2016 10:09'!
size

	^collection size.! !

!MTGLibrary methodsFor: 'public' stamp: 'SergioFedi 6/8/2016 09:35'!
top

	^collection last.! !

Object subclass: #MTGWizard
	instanceVariableNames: 'library hand'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MTGG'!

!MTGWizard methodsFor: 'public' stamp: 'SergioFedi 6/8/2016 10:31'!
addToHand: aLCS

	self hand add: aLCS.! !

!MTGWizard methodsFor: 'public' stamp: 'SergioFedi 6/8/2016 10:18'!
drawFromLibrary

	self addToHand: self library removeTop.! !

!MTGWizard methodsFor: 'public' stamp: 'SergioFedi 6/7/2016 21:46'!
hand

	^hand.! !

!MTGWizard methodsFor: 'private' stamp: 'SergioFedi 6/7/2016 21:48'!
initialize

	super initialize.

	hand := OrderedCollection new.
	library := OrderedCollection new.! !

!MTGWizard methodsFor: 'public' stamp: 'SergioFedi 6/8/2016 09:34'!
library
	^ library! !

!MTGWizard methodsFor: 'private' stamp: 'SergioFedi 6/7/2016 21:45'!
library: aCollection

	library := aCollection.! !
